﻿# PROGRAMME PREMIERE/TERMINALE SPECIALITE 2020
# -----------------------------------
# code proposé par Olivier CHAUMETTE - Lycée JPS Sartre - 69500 BRON
# -------------------------------------------------
# Représenter, à l'aide d'un langage de programmation, l'évolution des quantités
# de matière des espèce en fonction du volume de solution titrante versé
# ----------------------------------------------------------------------

import matplotlib.pyplot as plt


""" initialisation des données"""
# nombres steochiométriques des 2 réactifs
sto1=1
sto2=2

# premier réactif: le réactif titré
C1=0.01
V1=5   # V1 sera laissé en mL donc quantité de matière sera en mmol
# 2nd réactif: la solution titrante
C2=0.01
V2max=25    # en mL, volume max de solution titrante

# Formules des réactifs:
reactif1="I2"
reactif2="S2O3 2-"


# boucle permettant de calculer la quantité de matière de chaque espèce présente en fonction du Volume versé
for V2 in range(0,V2max+1):
    # Pour chaque ajout de V2,calcul des quantités de matière initiales:
    n1_ini=C1*V1
    n2_ini=C2*V2

    # PARTIE "détermination de xmax" du paragraphe 1
    if n1_ini/sto1>n2_ini/sto2:
        # réactif 2 limitant
        xmax=n2_ini/sto2
    else:
        xmax=n1_ini/sto1
        # réactif 1 limitant
    # Calcul des quantités finales
    # si n<0, c'est que n=0
    n1_fin=n1_ini-sto1*xmax
    if n1_fin<0:
        n1_fin=0
    n2_fin=n2_ini-sto2*xmax
    if n2_fin<0:
        n2_fin=0

    # affichage des points sur une courbe
    plt.plot(V2,n1_fin,"rx")
    plt.plot(V2,n2_fin,"bx")
# FIN  DE LA BOUCLE ###############

# affichage à nouveau des derniers points pour pouvoir mettre une legende
plt.plot(V2,n1_fin,"rx",label=reactif1)
plt.plot(V2,n2_fin,"bx",label=reactif2)

# axes du graphe
plt.xlabel("Volume V2 de solution titrante versée en mL")
plt.ylabel("Quantité de matière en mmol")
plt.title("Evolution des quantités de matière\n des espèces présentes \nen fonction du volume V2 versé")
# affichage de la legende
plt.legend()
# affichage de la fenêtre
plt.show()